#ifdef GL_ES
precision mediump float;
#endif

uniform float time;
uniform vec2 resolution;

vec2 ripple(vec2 o, vec2 p, float f){
	float d = distance(p, o);
	vec2 offset = vec2(0);
	offset.x = asin((p.x-o.x)/d)/3.1415 * sin(d*f-time);
	offset.y = asin((p.y-o.y)/d)/3.1415 * sin(d*f-time);
	return offset;
}

void main( void ) {
	vec2 p = (gl_FragCoord.xy/resolution.xy) - .5;
    
	vec2 dir = p - vec2(.5);
	float dist = distance(p, vec2(.5));
	vec2 offset = ripple(vec2(-0.2, 0.4), p, 50.);
	offset += ripple(vec2(0.4, -.6), p, 50.);
	offset += ripple(vec2(0.1, 0.2), p, 40.);
	offset += ripple(vec2(-0.2, -0.6), p, 40.);
	offset += ripple(vec2(0.3, 0.3), p, 40.);
	offset += ripple(vec2(-0.4, -0.2), p, 40.);
	p+=offset/40.;
    
	float c = offset.y;
	gl_FragColor = vec4(vec3(c), 1.0);
}